<?
		$rubrique = 3;
		$meta_description = "Les erreurs courantes en C";
		$meta_keywords = "erreur, courantes, langage, C, tutoriel, tutorial, cour, programmation, informatique";
		$titre_page = "Les erreurs courantes en C";
		$urlCss = "./article.css";
		$xhtml=true;
        
			$Auteur="Nicolas Joseph";
			$Licence="2";
			$Annee="2006";
		
		$dateBrute['date'] = '12 Septembre 2005';
		$dateBrute['miseajour'] = '';
		
				$topicType = 'Whitepaper';
			include("$DOCUMENT_ROOT/template/entete.php");
		?>
		  <div style="text-align:center;">
		  <table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
			<tr>
			  <td align="center" style="text-align:left">
	<br/><h1>Les erreurs courantes en C</h1><p class="dateArticle">
		Date de publication : 12 Septembre 2005</p><p style="text-align: center;">
        Par
        <a class="auteur" href="http://www.developpez.net/forums/member.php?u=41072">Nicolas Joseph</a> <a class="homepage" href="http://nicolasj.developpez.com"> (home)</a><br/>&nbsp;</p><div class="synopsis">
		Ce document regroupe une liste des erreurs les plus couramment rencontres par un programmeur en C, ainsi que des bonnes habitudes  prendre pour viter d'obtenir des comportements indfinis
	</div>
		<br /><a class="summaryIndent0" href="#LI">Confusion entre == et =</a>
			
			

			
			
		
		<br /><a class="summaryIndent0" href="#LII">Confusion entre le ET logique et le ET binaire</a>
			
			
		
		<br /><a class="summaryIndent0" href="#LIII">Confusion entre le OU logique et le OU binaire</a>
			
			
		
		<br /><a class="summaryIndent0" href="#LIV">Problme de boucle</a>
			
			

			
		
		<br /><a class="summaryIndent0" href="#LV">Fonctions retournant un caractre (*getc*)</a>
			
			

			

			
		
		<br /><a class="summaryIndent0" href="#LVI">Rcuprer le texte entr au clavier</a>
			
			

			

			
		
		<br /><a class="summaryIndent0" href="#LVI">Tester la fin d'un fichier</a>
			
			

			
		
		<br /><a class="summaryIndent0" href="#LVIII">Vider le buffer d'un flux entrant</a>
			
			

		
		<br /><a class="summaryIndent0" href="#LIX">Les chanes de caractres</a>
			
			

			

			

			

		
		<br /><a class="summaryIndent0" href="#LX">Allouer correctement de la mmoire</a>
			
			

			
			

		
		
		

		<br /><a class="summaryIndent0" href="#LXI">Tester le retour des fonctions</a>
			
			


		
		<br /><a class="summaryIndent0" href="#LXII">Oubli d'un break dans un switch</a>
			
			

			

			
		
		<br /><a class="summaryIndent0" href="#LXIII">Division entire</a>
			
			



		
		<br /><a class="summaryIndent0" href="#LXIV">Remerciements</a>
			
			
		
	<br/><br/>
		<br /><h1 class="TitreSection0" id="LI">Confusion entre == et =</h1>
			
			<div class="paragraph">
				Pour vrifier une galit, il faut utiliser l'oprateur == (constitu de deux signes gal) hors il est trs facile de n'en taper qu'un seul. Ceci a pour consquence de raliser une affectation :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_keyword">if</span> (size = 0)</span></pre></td></tr></table></div>
			<div class="paragraph">
				Dans ce cas, l'expression retourne 0, donc le bloc <b>if</b> ne sera jamais excut. Voici deux solutions possibles  :
			</div><br/>
			<ul style="list-style-type: disc;">
				<li>Bien rgler son compilateur : l'option -Wall de <b>gcc</b> signale ce genre d'erreur</li>
				<li>Utiliser la syntaxe :</li>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_keyword">if</span> (0==i)</span></pre></td></tr></table></div>
			<div class="paragraph">
				Ceci permet, en cas de faute de frappe, d'obtenir une erreur de la part du compilateur.
			</div><br/>
			</ul>
		
		<br /><h1 class="TitreSection0" id="LII">Confusion entre le ET logique et le ET binaire</h1>
			
			<div class="paragraph">
				Il est facile de confondre le ET logique (&amp;&amp;) qui retourne 0 ou 1 (en s'arrtant au premier argument s'il est faux) et le ET binaire (&amp;) qui, quant  lui, value ses deux oprandes. Cette confusion est plus difficile  dtecter que la prcdente puisque mme un compilateur bien rgl ne vous avertira pas de l'erreur.
			</div><br/>
		
		<br /><h1 class="TitreSection0" id="LIII">Confusion entre le OU logique et le OU binaire</h1>
			
			<div class="paragraph">
				Le problme est similaire au prcdent sauf que cette fois ci, il porte sur le OU logique (||) et sa version binaire (|). Le second oprande du OU logique n'est pas valu si le premier est vrai.
			</div><br/>
		
		<br /><h1 class="TitreSection0" id="LIV">Problme de boucle</h1>
			
			<div class="paragraph">
				Une erreur aussi courante et tout aussi difficile  dtecter que les prcdentes, il s'agit du point virgule en trop au niveau de l'instruction de boucle :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">int</span> i;
<span class="c_keyword">for</span> (i = 0; i &lt; 10; i++);
   printf (<span class="c_ch">"%d\n"</span>, i);</span></pre></td></tr></table></div>
			<div class="paragraph">
				Dans ce cas, la boucle <b>for</b> sera excute puis <i>i</i> sera affich avec la valeur de sortie de la boucle (10 dans notre cas). L'erreur est encore plus gnante avec une boucle <b>while</b> puisque le programme peut entrer dans une boucle sans fin.
			</div><br/>
		
		<br /><h1 class="TitreSection0" id="LV">Fonctions retournant un caractre (*getc*)</h1>
			
			<div class="paragraph">
				Les fonctions <b>fgetc</b>, <b>getc</b> et <b>getchar</b> permettent de rcuprer un caractre sur un flux d'entre (<i>stdin</i> pour <b>getchar</b>). Ces fonctions retournent un <b>int</b> et c'est  ce niveau que rside le problme en particulier lorsque la variable utilise pour stocker le retour de ces fonctions est un <b>char</b> :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="other_code">char c;
while ( (c = getchar ()) != EOF)
  ...</span></pre></td></tr></table></div>
			<div class="paragraph">
				Pour expliquer d'o vient le problme, voici les cast implicites raliss par le compilateur :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="other_code">while ( (int)(c = (char)getchar ()) != EOF)
  ...</span></pre></td></tr></table></div>
			<div class="paragraph">
				Or le caractre EOF (qui marque la fin d'un fichier : <b>E</b>nd <b>O</b>f <b>F</b>ile) est un caractre invalide gnralement gale  -1 mais il peut parfaitement tre gal  128, dans ce cas on dpasse la capacit de stockage d'un <b>char</b> et l'on se retrouve avec un rsultat gale  <b>-</b>128 : la condition du <b>while</b> sera toujours fausse, le programme boucle indfiniment!
			</div><br/>
		
		<br /><h1 class="TitreSection0" id="LVI">Rcuprer le texte entr au clavier</h1>
			
			<div class="paragraph">
				La premire fonction gnralement prsente pour rcuprer une saisie de l'utilisateur est <b>scanf</b> or il s'agit de l'une des fonctions les plus difficiles  matriser en C. Voici le genre de code que l'on peut trouver dans certains livres d'initiation :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">int</span> nombre;
scanf (<span class="c_ch">"%d"</span>, &amp;nombre);</span></pre></td></tr></table></div>
			<div class="paragraph">
				Premirement le risque d'oublier le <b>&amp;</b> devant les paramtres de <b>scanf</b> est assez important. Deuximent que se passe-t-il si l'utilisateur entre autre chose qu'un entier (du texte par exemple)? On obtient un comportement indfini! Et dans le cas de la saisie de texte, voici un autre code d'exemple :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">char</span> texte[20];
scanf (<span class="c_ch">"%s"</span>, texte);</span></pre></td></tr></table></div>
			<div class="paragraph">
				Tout aussi dangereux! Qu'est ce qui empche l'utilisateur de saisir plus de 19 caractres? Dans ce cas rien<a class="signetNoteBasPage" id="signetNoteBasPage1" href="#noteBasPage1">(1)</a>! La fonction <b>gets</b> peut sembler pratique pour rcuprer du texte mais l'on retrouve le mme problme du contrle de la taille du texte saisi.<br />
				Il reste plus qu'une fonction<a class="signetNoteBasPage" id="signetNoteBasPage2" href="#noteBasPage2">(2)</a> : <b>fgets</b>, c'est la seule fonction qui doit tre utilise pour rcuprer une chane de caractre. Pour rcuprer des nombres, il suffit de convertir le rsultat de <b>fgets</b> grce  <b>strtol</b> ou <b>strtod</b> (<b>atoi</b> et <b>atof</b> tant obsoltes).
			</div><br/>
		
		<br /><h1 class="TitreSection0" id="LVI">Tester la fin d'un fichier</h1>
			
			<div class="paragraph">
				On trouve souvent ce genre de test :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">FILE *stream;
...
<span class="c_keyword">while</span> (!feof (stream))
...</span></pre></td></tr></table></div>
			<div class="paragraph">
				La fonction <b>feof</b> n'est pas faite pour cela. Il faut tester le retour de la fonction de saisie (<b>fgets</b> ou <b>fgetc</b>) qui retourne NULL ou EOF en cas d'erreur ou de fin de fichier et ensuite seulement on peut utiliser <b>feof</b> pour connatre la cause de l'arrt de la lecture du flux.
			</div><br/>
		
		<br /><h1 class="TitreSection0" id="LVIII">Vider le buffer d'un flux entrant</h1>
			
			<div class="paragraph">
				La fonction <b>fflush</b> permet de vider le tampon des flux sortants et uniquement ceci! Son utilisation dans le cas d'un flux entrant (<i>stdin</i> par exemple) entrane un comportement indefini, on utilisera donc :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">int</span> ch;
<span class="c_keyword">while</span>( (ch = fgetc(fp)) != EOF &amp;&amp; ch != '\n' )
  ;</span></pre></td></tr></table></div>
		
		<br /><h1 class="TitreSection0" id="LIX">Les chanes de caractres</h1>
			
			<div class="paragraph">
				En C, les chanes de caractres n'existent pas, il s'agit de tableaux de caractres termins par un caractre nul (\0). Lors de la cration d'une chane, il ne faut pas oublier de prvoir une case de plus pour y stocker ce marqueur de fin de chane :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">char</span> src[] = <span class="c_ch">"Developpez"</span>;
<span class="c_type">char</span> *dst = <span class="c_keyword">NULL</span>;

dst = malloc (<span class="c_keyword">sizeof</span> (*dst) * 10);
strcpy (dst, src);</span></pre></td></tr></table></div>
			<div class="paragraph">
				L'utilisation de <i>dst</i> comme une chane de caractre provoquera un comportement indfini. Pour les mmes raisons, il n'est pas possible de comparer deux chanes grce  l'oprateur d'galit (==) :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">char</span> str1[] = <span class="c_ch">"abc"</span>;
<span class="c_type">char</span> str2[] = <span class="c_ch">"abc"</span>;

<span class="c_keyword">if</span> (str1 == str2)
  printf (<span class="c_ch">"str1 et identique a str2"</span>);
<span class="c_keyword">else</span>
  printf (<span class="c_ch">"str1 et different de str2"</span>);</span></pre></td></tr></table></div>
			<div class="paragraph">
				Ce code affichera toujours que les deux chanes sont diffrentes puisque l'on compare les adresses des variables <i>str1</i> et <i>str2</i>. Pour que le code fasse ce que l'on souhaite, il faut utiliser la fonction <b>strcmp</b>.<br />
				Pour en finir avec les chanes de caractres, l'expression :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">char</span> *texte = <span class="c_ch">"Developpez"</span>;</span></pre></td></tr></table></div>
			<div class="paragraph">
				N'alloue pas de mmoire pour stocker la chane, on se contente de mmoriser l'adresse de la chane. Hors rien de garantie que celle-ci est stocke dans une zone de mmoire accssible en criture, par prcaution, il vaut mieu crire :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_keyword">const</span> <span class="c_type">char</span> *texte = <span class="c_ch">"Developpez"</span>;</span></pre></td></tr></table></div>
		
		<br /><h1 class="TitreSection0" id="LX">Allouer correctement de la mmoire</h1>
			
			<div class="paragraph">
				Pour allouer de la mmoire, il faut utiliser la fonction <b>malloc</b> (ou <b>calloc</b> au choix) qui demande la taille de la zone  allouer. Il est d'usage courant d'utiliser le type pour dterminer cette taille :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">int</span> *tab = malloc (<span class="c_keyword">sizeof</span> (<span class="c_type">int</span>) * BUFSIZ);</span></pre></td></tr></table></div>
			<table class="tableau" style="width: 98%; text-align: left; border:0;"><tr><td style="width: 40px; vertical-align: top;" class="colonne"><img src="http://www.developpez.be/images/kitwarning.gif" alt="warning"/></td><td class="colonne">
				Avant de continuer je tiens  signaler qu'il est dconseill de caster le retour de <b>malloc</b>, puisque premirement c'est inutil<a class="signetNoteBasPage" id="signetNoteBasPage3" href="#noteBasPage3">(3)</a> et secondement cela peut cacher l'absence d'inclusion de <i>stdlib.h</i>.
			<br/></td></tr></table>
			<div class="paragraph">
				Il peut arriver que le type de <i>tab</i> soit modifi, dans ce cas il faut reprendre tous les appels  <b>malloc</b> pour les modifier et en cas d'oubli la sanction peut tre lourde de consquence. C'est pourquoi je vous conseille d'utiliser le nom de la variable pour retrouver la taille de l'lment point :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">int</span> *tab = malloc (<span class="c_keyword">sizeof</span> (*tab) * BUFSIZ);</span></pre></td></tr></table></div>
		
		<div class="paragraph">
			Dans ce cas plus de problme! Et si on modifie le nom de la variable? Si vous oubliez un ancien nom dans le fichier source, c'est le compilateur qui se chargera de vous le rappeler.
		</div><br/>
		<table class="tableau" style="width: 98%; text-align: left; border:0;"><tr><td style="width: 40px; vertical-align: top;" class="colonne"><img src="http://www.developpez.be/images/kitidea.gif" alt="idea"/></td><td class="colonne">
			La fonction <b>free</b> gre parfaitement le cas o l'adresse qui lui ai passe en argument est NULL, il est donc inutile d'crire ceci :
		<br/></td></tr></table>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_keyword">if</span> (p != <span class="c_keyword">NULL</span>)
  free (p);</span></pre></td></tr></table></div>
		<br /><h1 class="TitreSection0" id="LXI">Tester le retour des fonctions</h1>
			
			<div class="paragraph">
				Certaines fonctions peuvent chouer (je pense en particulier  <b>malloc</b> et <b>fopen</b>) il est donc bon de tester leurs valeurs de retour pour savoir si l'on peut continuer. Pour illustrer ceci, voici comment utiliser correctement la fonction <b>realloc</b> pour ne pas avoir de surpise :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">void</span> *tmp = <span class="c_keyword">NULL</span>;
<span class="c_type">char</span> *p = <span class="c_keyword">NULL</span>;
...
tmp = realloc (p, <span class="c_keyword">sizeof</span> (*p) * BUFSIZ);
<span class="c_keyword">if</span> (tmp != <span class="c_keyword">NULL</span>)
{
   p = tmp;
   <span class="c_comment">/* Le programme continue normalement */</span>
}
<span class="c_keyword">else</span>
{
   free (p);
   <span class="c_comment">/* Il faut informer l'utilisateur du manque de
   memoire et quitter proprement l'application */</span>
}</span></pre></td></tr></table></div>

		
		<br /><h1 class="TitreSection0" id="LXII">Oubli d'un break dans un switch</h1>
			
			<div class="paragraph">
				L'instruction <b>switch</b> n'est qu'un <b>goto</b> dguis qui saute vers l'instrcution <b>case</b> correspondante et c'est tout! Si vous crivez ceci :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">int</span> val = 1;
<span class="c_keyword">switch</span> (val)
{
   <span class="c_keyword">case</span> 1:
      printf (<span class="c_ch">"val=1\n"</span>);
   <span class="c_keyword">case</span> 2:
      printf (<span class="c_ch">"val=2\n"</span>);
}</span></pre></td></tr></table></div>
			<div class="paragraph">
				Le programme affichera les deux textes, pour n'afficher qu'un texte par valeur, il faut ajouter l'instruction <b>break</b> :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">int</span> val = 1;
<span class="c_keyword">switch</span> (val)
{
   <span class="c_keyword">case</span> 1:
      printf (<span class="c_ch">"val=1\n"</span>);
   <span class="c_keyword">break</span>;
   <span class="c_keyword">case</span> 2:
      printf (<span class="c_ch">"val=2\n"</span>);
   <span class="c_keyword">break</span>;
}</span></pre></td></tr></table></div>
			<div class="paragraph">
				Le second <b>break</b> n'est pas indispensable mais cela vitera de l'oublier en cas d'ajout de nouvelles valeurs.
			</div><br/>
		
		<br /><h1 class="TitreSection0" id="LXIII">Division entire</h1>
			
			<div class="paragraph">
				Pour raliser une division entire ou relle, le C utilise le mme oprateur (/). Par consquent pour savoir quel rsultat retourner, le compilateur se base sur le type des oprandes. Voici diffrents exemples avec le rsultat obtenu :
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">double</span> a = 1/2 <span class="c_comment">/* = 0 */</span></span></pre></td></tr></table></div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">double</span> b = 1.0/2 <span class="c_comment">/* = 0.5 */</span></span></pre></td></tr></table></div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">int</span> a = 1, b = 2;
<span class="c_type">double</span> c = ((<span class="c_type">double</span>) a)/b; <span class="c_comment">/* = 0.5 */</span></span></pre></td></tr></table></div>
		
		<br /><h1 class="TitreSection0" id="LXIV">Remerciements</h1>
			
			<div class="paragraph">
				 Merci  Gnux pour la relecture attentive de cet article.
			</div><br/>
		
	<br/><hr/><table class="noteBasPage"><tr><td class="col1NoteBasPage"><a class="noteBasPage" id="noteBasPage1" href="#signetNoteBasPage1">(1)</a></td><td class="col2NoteBasPage"><span class="noteBasPage">Il existe un moyen de limiter la taille de la chane rcupre par <b>scanf</b> en utilisant les paramtres de formatage.</span></td></tr><tr><td class="col1NoteBasPage"><a class="noteBasPage" id="noteBasPage2" href="#signetNoteBasPage2">(2)</a></td><td class="col2NoteBasPage"><span class="noteBasPage">Rien ne vous empche de coder votre propre fonction en utilisant <b>fgetc</b>, voici une exemple que j'utilise dans mes projets : <a href="http://nicolasj.developpez.com/sources/getnextline/" class="lienArticle">getNextLine</a>.</span></td></tr><tr><td class="col1NoteBasPage"><a class="noteBasPage" id="noteBasPage3" href="#signetNoteBasPage3">(3)</a></td><td class="col2NoteBasPage"><span class="noteBasPage">Le cast d'un pointeur <b>void</b> est inutile en C contrairement au C++ : <a href="http://nicolasj.developpez.com/articles/incompatibilites/" class="lienArticle">Les incompatibilits entre le C et le C++</a></span></td></tr></table><hr/><p style="text-align:center;"><a href="http://validator.w3.org/check?uri=referer"><img src="http://www.w3.org/Icons/valid-xhtml11" alt="Valid XHTML 1.1!" height="31" width="88"/></a><a href="http://jigsaw.w3.org/css-validator/check/referer"><img style="border:0;width:88px;height:31px" src="http://jigsaw.w3.org/css-validator/images/vcss" alt="Valid CSS!"/></a></p><div id="xiti-logo" style="text-align:center;">
<a href="http://www.xiti.com/xiti.asp?s=205564" title="Mesurez votre audience">
<script type="text/javascript">
<!--
Xt_param = 's=205564&p=articles/erreurs';
Xt_r = document.referrer;
Xt_h = new Date();
Xt_i = '<img width="39" height="25" border="0" ';
Xt_i += 'src="http://logv28.xiti.com/hit.xiti?'+Xt_param;
Xt_i += '&hl='+Xt_h.getHours()+'x'+Xt_h.getMinutes()+'x'+Xt_h.getSeconds();
if(parseFloat(navigator.appVersion)>=4)
{Xt_s=screen;Xt_i+='&r='+Xt_s.width+'x'+Xt_s.height+'x'+Xt_s.pixelDepth+'x'+Xt_s.colorDepth;}
document.write(Xt_i+'&ref='+Xt_r.replace(/[<>"]/g, '').replace(/&/g, '$')+'" title="Analyse d\'audience">');
//-->
</script>
<object>
<noscript>
<div id="xiti-logo-noscript-205564">
Mesure d'audience ROI frequentation par <img width="39" height="25" src="http://logv28.xiti.com/hit.xiti?s=205564" alt="Analyse d'audience" />
</div>
</noscript>
</object>
</a></div>
	  </td>
		</tr>
		   </table></div>
<?
	include("$DOCUMENT_ROOT/template/pied.php");?>